;Programa del MarvicFix 1.0
;Con Modo test y seleccin 
;Si desea mejorar el codigo lo puede hacer
;siempre y cuando mensione su autor original
;MARVICDIGITAL despues de contar con el permiso
;para publicarlo

gpio	equ	06h
w	equ	0h
teston         equ            0ch
control        equ            00h
reset          equ            01h
eject          equ            02h
sens           equ            03h
pico           equ            0dh
tempo          equ            0eh
tempo2         equ            0fh
memory         equ            10h


reinicio	org	0
	goto	inicio
	org            5
;************** timer de 10ms ***********
timer          movlw          d'10'
               movwf          tempo
timer2         movlw          d'110'
               movwf          tempo2
temp           nop
               nop
               nop
               nop
               nop
               nop
               decfsz         tempo2
               goto           temp
               decfsz         tempo
               goto           timer2
               retlw          0

inicio	movlw          b'111110'
               tris           gpio
               call           timer
               bsf            gpio,control
modotest       nop
               btfss          gpio,reset
               goto           test_off
               nop
antirrebote    movlw          d'10'
               movwf          pico
check          call           timer
               decfsz         pico
               goto           check
               nop
               btfsc          gpio,reset
               goto           antirrebote
               nop
modo_dvd       btfsc          gpio,sens   ;este paso es para chips como el 
               goto           modo_normal    ;Magic o en donde se presiona el 
               nop                           ;reset hasta que salga la presentacin
               btfss          gpio,reset     ;inicial para leer DVD Movie y PSone
               goto           modo_dvd       ;tambien hace un check sobre la corriente
               nop
eject_con      movlw          d'10'
               movwf          pico
eject_ch       call           timer          ;Aca seleccionamos la sensibilidad del fix
               decfsz         pico           ;tapa abierta al encender selecciona 400ms
               goto           eject_ch       ;y cerrada al encender selecciona 250ms
               nop
               btfss          gpio,eject
               goto           pico2
               nop                   
modo_normal    movlw          d'25'           ;incrementar valor hasta un mximo de 50
               movwf          memory           ;esto vara el ancho de pulso permitido
               goto           read_mem
pico2          movlw          d'40'
               movwf          memory
               nop
sensor         btfss          gpio,reset
               goto           apagar
               nop
               btfss          gpio,sens
               goto           sensor
read_mem       movf           memory,w
               movwf          pico
ancho          call           timer          ;para las bobinas X 10ms
               nop
               decfsz         pico
               goto           ancho
               nop
               btfss          gpio,sens
               goto           sensor
               nop
power_off      clrf           pico
               movlw          d'220'
               movwf          pico
pstwo_off      call           timer
               nop
               bcf            gpio,control
               decfsz         pico
               goto           pstwo_off
               nop
               goto           inicio
test_off       nop
               btfss          gpio,sens
               goto           test_off
               nop
               goto           power_off
apagar         movlw          d'200'
               movwf          pico
apagar_1       btfsc          gpio,reset
               goto           read_mem
               nop
               call           timer
               decfsz         pico
               goto           apagar_1
               nop
soltar         btfss          gpio,reset
               goto           soltar
               nop
               goto           antirrebote               
               end




